<?php
namespace Teknisa\FIS\Controllers;

use Teknisa\FIS\Services\Fis02600ClassificacaoFiscalService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\DataSet as Data;
use Zeedhi\Framework\DTO\Response\Error; 
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\XLS\Exception;
use Zeedhi\Framework\DTO\Response;


use Teknisa\FIS\Controllers\TeknisaCrud;
use Teknisa\FIS\Factories;
use Teknisa\FIS\Strategies;
use Teknisa\FIS\Strategies\Context;
use Teknisa\FIS\Controllers\Import\XlsImportFile;
use \Doctrine\ORM\EntityManager;
use \Teknisa\Libs\Util\Address;
use \Teknisa\Libs\Util\NewCode;

class Fis02600ClassificacaoFiscalController extends TeknisaCrud {
    
    protected $crudService;
    
    public function __construct($crudService, ParameterBag $parameterBag, Fis02600ClassificacaoFiscalService $service, $entityManager, Environment $environment, NewCode $newCode) {
        parent::__construct($crudService, $parameterBag);
        $this->service = $service;
        $this->crudService = $crudService;
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->newCode = $newCode;
    }
    
    public function importXls(DTO\Request $request, DTO\Response $response){
        try{
            ini_set('memory_limit', '1024M');
            ini_set('max_execution_time', '7200');
            set_time_limit(7200);
            $row = $request->getRow();
            $table = $this->service->readXls($row);
            $rows = $this->service->formatXls($table);
            $response->addDataSet(new DataSet('import', $rows));
        }
        catch(Exception $e){
            $errors = $e->getErrors();
            $response->addDataSet(new DataSet('errors', $errors));
            $response->setError(new Error($e->getMessage(), 500)); 
        }
        catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function insereNCM(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        $retorno = $this->service->insereNCM($row);
        $response->addDataSet(new DataSet("retorno", array("message" => $retorno)));
    }
    
}