var Fis00811_RelatorioImpostosPorNota_Controller = function(templateManager, ZhFilterPreferences, ScreenService) {

    this.IMPOSTO_FEDERAL   = 'F';
    this.IMPOSTO_ESTADUAL  = 'E';
    this.IMPOSTO_MUNICIPAL = 'M';
    
    this.openFilter = function(widget){
        var rowsToSet = {};
        rowsToSet.IDENTRSAIDOP = "E";
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };
    
    this.filtraTipoOperacao = function(widget){
        widget.getField('CDTIPOOPER').dataSourceFilter[0].value = widget.getField('IDENTRSAIDOP').value();
        widget.getField('CDTIPOOPER').reload();
    };
    
    this.filterMapaApuracao = function(widget, field){
        var mapa = widget.getField('NRSEQUMAPAPU');
        mapa.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDINSCESTA': filter.value = (widget.currentRow.CDINSCESTA) ? widget.currentRow.CDINSCESTA : null;
                    break;
                case 'CDINSCMUNI': filter.value = (widget.currentRow.CDINSCMUNI) ? widget.currentRow.CDINSCMUNI : null;
                    break;
            }
        });
        if (field){
            mapa.readOnly = (field.value()) ? false : true;
        }
    };
    
    this.preparaFiltroImpostoNota = function(widget, preference){
        var filial = Array.isArray(preference.FILTER_ROW.CDFILIAL) ? preference.FILTER_ROW.CDFILIAL.join('_') : preference.FILTER_ROW.CDFILIAL;
        var cdtipooper = Array.isArray(preference.FILTER_ROW.CDTIPOOPER) ? preference.FILTER_ROW.CDTIPOOPER.join('_') : preference.FILTER_ROW.CDTIPOOPER;
        var valuesCustomFilter = {'CDFILIAL': filial, 'CDTIPOOPER': cdtipooper};
        widget.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDTIPOOPER': filter.value = (cdtipooper) ? cdtipooper : null;
                    break;
                case 'NRSEQUMAPAPU': filter.value = (preference.FILTER_ROW.NRSEQUMAPAPU) ? preference.FILTER_ROW.NRSEQUMAPAPU : null;
                    break;
                case 'CDFILIAL': filter.value = (filial) ? filial : null;
                    break;
                case 'IDENTRSAIDOP': filter.value = (preference.FILTER_ROW.IDENTRSAIDOP) ? preference.FILTER_ROW.IDENTRSAIDOP : null;
                    break;
            }
        });  
        this.removeFieldsClausulaWhere(widget, preference, valuesCustomFilter);
    };
    
    this.removeFieldsClausulaWhere = function(widget, preference, valuesCustomFilter){
        var filtrosRemoviveis = ['CDEMPRESA', 'NMFILIAL'];
        var dataSourceFilter = widget.dataSourceFilter;
        for (var i = dataSourceFilter.length - 1; i >= 0; i--) {
            if (filtrosRemoviveis.includes(dataSourceFilter[i].name)){
	        	dataSourceFilter.splice(i, 1);
	        }
        }
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        for (var key in preference.CUSTOM_FILTER_ROW) {
            if (filtrosRemoviveis.includes(key)){
                delete preference.CUSTOM_FILTER_ROW[key];
            }
            if (valuesCustomFilter.hasOwnProperty(key)){
                preference.CUSTOM_FILTER_ROW[key] = valuesCustomFilter[key];
            }
        }
    };
    
    this.validaCompetenciaSobreImposto = function(widget){
        var empresa = widget.currentRow.CDEMPRESA;
        var imposto = widget.currentRow.CDIMPOSTO;
        var fieldMapa = widget.getField('NRSEQUMAPAPU');
        var inscricaoEstadual = widget.getField('CDINSCESTA');
        var inscricaoMunicipal = widget.getField('CDINSCMUNI');
        if (empresa && imposto) {
            fieldMapa.value(null);
            this.setValuesFilter(fieldMapa, widget);
            inscricaoEstadual.dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            inscricaoMunicipal.dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_FEDERAL){
                inscricaoEstadual.readOnly     = true;
                inscricaoMunicipal.readOnly    = true;
                inscricaoEstadual.validations  = {};
                inscricaoMunicipal.validations = {};
                widget.currentRow.CDINSCESTA   = null;
                widget.currentRow.CDINSCMUNI   = null;
                fieldMapa.readOnly             = false;
                fieldMapa.clearValue();
            }else if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_ESTADUAL){
                inscricaoEstadual.readOnly     = false;
                inscricaoEstadual.validations  = {'required': true};
                inscricaoMunicipal.readOnly    = true;
                inscricaoMunicipal.validations = {};
                widget.currentRow.CDINSCMUNI   = null;
                fieldMapa.readOnly             = true;
                fieldMapa.clearValue();
            }else if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_MUNICIPAL){
                inscricaoEstadual.readOnly     = true;
                inscricaoEstadual.validations  = {};
                inscricaoMunicipal.readOnly    = false;
                inscricaoMunicipal.validations = {'required': true};
                widget.currentRow.CDINSCESTA   = null;
                fieldMapa.readOnly             = true;
                fieldMapa.clearValue();
            }  
        } else {
            fieldMapa.readOnly = true;
            widget.currentRow.NMMAPAAPUR = null;
            widget.currentRow.NRSEQUMAPAPU = null;
            widget.currentRow.DTINIPERIODO = null;
            widget.currentRow.DTFIMPERIODO = null;
            inscricaoEstadual.readOnly     = true;
            inscricaoEstadual.validations  = {};
            inscricaoMunicipal.readOnly    = true;
            inscricaoMunicipal.validations = {};
            widget.currentRow.CDINSCESTA   = null;
            widget.currentRow.CDINSCMUNI   = null;
        }
        this.filterMapaApuracao(widget);
    };
    
    this.setValuesFilter = function(field, widget){
        field.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA': filter.value = widget.currentRow.CDEMPRESA;
                    break;
                case 'CDIMPOSTO': filter.value = widget.currentRow.CDIMPOSTO;
                    break;
            }
        });
    };
    
    this.setNameLayout = function(args){
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Fis00811_RelatorioImpostosPorNota_Controller', Fis00811_RelatorioImpostosPorNota_Controller);
});